﻿public class HoneycombRefiners : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.honeycomb-refiners";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    [HarmonyLib.HarmonyPatch(typeof(Tank), "OnRayEnter")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_Tank_OnRayEnter
    {
        static void Prefix(ref System.Collections.Generic.List<Item_Base> ___acceptableTypes, ref Tank __instance)
        {
            if (__instance.name == "HoneyTank")
            {
                ___acceptableTypes.Add(ItemManager.GetItemByName("HoneyComb"));
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(LiquidFuelManager), "GetFilteredFuelValueSoFromItem")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_LiquidFuelManager_GetFilteredFuelValueSoFromItem
    {
        static void Postfix(ref Item_Base item, ref FuelValue_FiltrationType fVFilterType, ref System.Collections.Generic.Dictionary<FuelValue_FiltrationType, System.Collections.Generic.List<SO_FuelValue>> ___fuelValueDictionary, ref SO_FuelValue __result)
        {
            if (item.UniqueName == "HoneyComb" && fVFilterType == FuelValue_FiltrationType.FV_COMPOSTHONEYTANK)
            {
                __result = UnityEngine.ScriptableObject.CreateInstance<SO_FuelValue>();
                __result.itemType = item;
                __result.fuelValueOfType = 1;
                __result.fuelFiltrationType = fVFilterType;
            }
        }
    }
}
